services:
  registry:
    image: "registry:${REGISTRY_TAG}"
    restart: always
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=traefik"
      - "traefik.http.routers.secure-registry.rule=Host(`${REGISTRY_DOMAIN}`)"
      - "traefik.http.routers.secure-registry.entrypoints=https"
      - "traefik.http.routers.secure-registry.tls.certresolver=httpchallenge"
      - "traefik.http.services.secure-registry.loadbalancer.server.port=5000"
    environment:
      - TZ=${TZ}
      - REGISTRY_AUTH=htpasswd
      - REGISTRY_AUTH_HTPASSWD_REALM=Registry
      - REGISTRY_AUTH_HTPASSWD_PATH=/auth/htpasswd
      - REGISTRY_STORAGE_DELETE_ENABLED=${REGISTRY_STORAGE_DELETE_ENABLED}
      # This is a bug fix for panic: readonly config key must contain additional keys
      # @see https://github.com/docker/distribution/issues/1736#issuecomment-509676628
      - REGISTRY_STORAGE_MAINTENANCE_READONLY={enabled:${REGISTRY_STORAGE_MAINTENANCE_READONLY_ENABLED}}
    volumes:
      - "${REGISTRY_STORAGE}/registry/auth:/auth:ro"
      - "${REGISTRY_STORAGE}/registry/data:/var/lib/registry"
    networks:
      - traefik
networks:
  traefik:
    name: traefik
    external: true
